(*
NOMBRE COMPLETO:
...
*)

Require Export List.

Require Import Lia.

Require Export Arith.
Print beq_nat.


Section Problema1.

Fixpoint eliminar (z:nat) (l:list nat) {struct l} : list nat :=
...


Fixpoint pertenece (z:nat) (l:list nat) {struct l} : bool :=
...


Lemma L1_1: forall (A:Set) (l:list A) (x:A), l <> x::l.
Proof. 
...
Qed.


Lemma L1_2: forall (l:list nat) (x:nat), 
  pertenece x l = true -> eliminar x l <> l.
Proof. 
...
Qed.


End Problema1.


Section Problema2.

Inductive distintas (A:Set) : list A -> list A -> Prop :=
...

Hint Constructors distintas.


Lemma L2: forall (l1:list bool), 
  { l2: list bool | distintas bool l1 l2 }.
Proof. 
...
Qed.

...

End Problema2.


Section Problema3.
 
Definition Var := nat.
Definition Valor := nat.

Definition Memoria := Var -> Valor.

Definition lookup (m : Memoria) (v : Var) : Valor := 
...
 
Definition update (m : Memoria) (v : Var) (w : Valor) : Memoria :=
...
 
Inductive Instr : Set :=
...
 
Inductive Execute : Memoria -> Instr -> Memoria -> Prop :=
...


Lemma L3_1: forall (m1 m2:Memoria)(v:Var) (val:Valor) (I1 I2:Instr), ...
Proof.
...
Qed.


Lemma L3_2: forall (m1 m2 m3:Memoria)(v1 v2:Var) (val:Valor) (I1 I2:Instr), ...
Proof.
...
Qed.
 
End Problema3.
